package ru.octol1ttle.knockdowns.common;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import net.minecraft.entity.player.EntityPlayer;

public class ReviverTracker {
    private static final Map<EntityPlayer, List<EntityPlayer>> knockedToReviversMap = new HashMap<>();

    public static void startReviving(EntityPlayer knocked, EntityPlayer reviver) {
        getRevivers(knocked).add(reviver);
    }

    public static void stopReviving(EntityPlayer knocked, EntityPlayer reviver) {
        getRevivers(knocked).remove(reviver);
    }

    public static void clearRevivers(EntityPlayer knocked) {
        getRevivers(knocked).clear();
    }

    public static List<EntityPlayer> getRevivers(EntityPlayer knocked) {
        return knockedToReviversMap.computeIfAbsent(knocked, player -> new ArrayList<>());
    }

    public static Set<Map.Entry<EntityPlayer, List<EntityPlayer>>> getAllRevivers() {
        return knockedToReviversMap.entrySet();
    }
}
